



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>sql（Oracle）优化之索引</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">sql（Oracle）优化之索引</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 23:11:43 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>原文：https://www.cnblogs.com/oraclestudy/articles/5779210.html</p>
<p>建立索引的目的是：<br />l 提高对表的查询速度；<br />l 对表有关列的取值进行检查。</p>
<p>注意：一个基表不能建太多的索引；<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 空值不能被索引<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 只有唯一索引才真正提高速度,一般的索引只能提高30%左右。</p>
<p>Oracle对象教程：索引(Index)创建使用，索引：对数据库表中的某些列进行排序，便于提高查询效率。</p>
<p>当我们在某本书中查找特定的章节内容时，可以先从书的目录着手，找到该章节所在的页码，然后快速的定位到该页。这种做法的前提是页面编号是有序的。如果页码无序，就只能从第一页开始，一页页的查找了。</p>
<p>数据库中索引(Index)的概念与目录的概念非常类似。如果某列出现在查询的条件中，而该列的数据是无序的，查询时只能从第一行开始一行一行的匹配。创建索引就是对某些特定列中的数据排序，生成独立的索引表。在某列上创建索引后，如果该列出现在查询条件中，Oracle会自动的引用该索引，先从索引表中查询出符合条件记录的ROWID，由于ROWID是记录的物理地址，因此可以根据ROWID快速的定位到具体的记录，表中的数据非常多时，引用索引带来的查询效率非常可观。</p>
<p>&middot;如果表中的某些字段经常被查询并作为查询的条件出现时，就应该考虑为该列创建索引。</p>
<p>&middot;当从很多行的表中查询少数行时，也要考虑创建索引。有一条基本的准则是：当任何单个查询要检索的行少于或者等于整个表行数的10%时，索引就非常有用。</p>
<p>Oracle数据库会为表的主键和包含唯一约束的列自动创建索引。索引可以提高查询的效率，但是在数据增删改时需要更新索引，因此索引对增删改时会有负面影响。</p>
<p><strong>语法结构：创建索引</strong></p>
<div>
<table>
<tbody>
<tr>
<td>
<p>CREATE [UNIQUE] INDEX index_name ON table_name(column_name[,column_name&hellip;])</p>
</td>
</tr>
</tbody>
</table>
</div>
<p><strong>语法解析：</strong></p>
<p>1. UNIQUE:指定索引列上的值必须是唯一的。称为唯一索引。</p>
<p>2. index_name：指定索引名。</p>
<p>3. tabl_name：指定要为哪个表创建索引。</p>
<p>4. column_name：指定要对哪个列创建索引。我们也可以对多列创建索引;这种索引称为组合索引。</p>
<p>案例4：为EMP表的ENAME列创建创建唯一索引，为EMP表的工资列创建普通索引，把JOB列先变为小写再创建索引。</p>
<p>代码演示：创建索引</p>
<div>
<table>
<tbody>
<tr>
<td>
<p>SQL&gt; CREATE UNIQUE INDEX UQ_ENAME_IDX ON EMP(ENAME); &nbsp;①</p>
<p>Index created</p>
<p>SQL&gt; CREATE INDEX IDX_SAL ON EMP(SAL); &nbsp;②</p>
<p>Index created</p>
<p>SQL&gt; CREATE INDEX IDX_JOB_LOWER ON EMP(LOWER(JOB));&nbsp;&nbsp;③</p>
<p>Index created</p>
</td>
</tr>
</tbody>
</table>
</div>
<p>代码解析：</p>
<p>① 为SCOTT.EMP表的ENAME列创建唯一索引。</p>
<p>② 为SCOTT.EMP表的SAL列创建索引。</p>
<p>③ 在查询中可能经常使用job的小写作为条件的表达式，因此创建索引时，可以先对JOB列中的所有值转换为小写后创建索引，而这时需要使用lower函数，这种索引称为基于函数的索引。</p>
<p>在select语句查询时，Oracle系统会自动为查询条件上的列应用索引。索引就是对某一列进行排序，因此在索引列上，重复值越少，索引的效果越明显。</p>
<p>Oracle可以为一些列值重复非常多且值有限的列(比如性别列)上创建位图索引。关于Oracle更多的索引类型(比如反向键索引等)，请参考Oracle官方文档。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495gvdzq.html">MySQL Doublewrite Buffer及业务评估</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxlo40q.html">phpMyAdmin提示：配置文件权限错误，无法写入！解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jekvg8.html">&lbrack;WinApi&rsqb; C&num;获取其他窗口文本框内容（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlyl2k9.html">磁盘 I&sol;O 性能监控指标和调优方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mzzzgq.html">VS2013项目配置directx11</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k126er9.html">Visifire的一些使用心得</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z16xxn9.html">文件存储之-内存文件系统tmpfs</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yxong8.html">每周日与周四《红酒屋》探戈舞会&quot;Wine Bar&quot; Milonga&lowbar;原生态拉丁&lowbar;新浪博客</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kppzd39.html">他们控制的定义-DragButton</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z7rm59.html">Another Easy Problem   fzu1753</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpdd559.html">Angular 报错 Can&amp;&num;39&semi;t bind to &amp;&num;39&semi;formGroup&amp;&num;39&semi; since it isn&amp;&num;39&semi;t a known property of &amp;&num;39&semi;form&amp;&num;39&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/950nemz8.html">Effective Java 第三版&mdash;&mdash;16&period;在公共类中使用访问方法而不是公共属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pde7d49.html">HTTP协议的简单介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1o25jq.html">ORACLE数据库SQL优化 not in 与not exits</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zlgke9.html">redis实战笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj05er9.html">arcgis raster clip and mask difference 栅格 提取 clip 和 mask 方法的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1vyx1q.html">js取指定范围随机值【原】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv20yw19.html">【AtCoder】ARC072</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwgeyz8.html">Vue疑难杂症</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j23e0q.html">delphi-TTcpServer与TTcpClient</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pwldzd8.html">WCF  基础连接已经关闭&colon; 服务器关闭了本应保持活动状态的连接。</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25pk6wq.html">python的命令行参数处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll617eq.html">rsync同步目录</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvpn328.html">生成当前目录文件的xml描述</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ok7mk8.html">Reg2Bat&lowbar;By Slore（生成同名bat文件，支持XP WIN7 WIN7X64）&period;vbs</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwlmm78.html">Tomacat 配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ok7yj8.html">【Properties】获取Properties文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjxv1r9.html">使用StringEscapeUtils对Java中特殊字符进行转义和反转义</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j15lxg9.html">TextView-- 测量文字宽度</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ok0ye8.html">sas share 备忘录</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
